//.b 	
//	Copyright 2001-2005 Botmeister
//	
//	File: tools.cpp
//	
//	General Library Definitions and Routines. 
//
//.e	

// Include definition files.
	#include "tools.h"
	#include <stdio.h>
	#include <io.h>

	bool fboCharStrIsOK( char* pch_ptr, unsigned long pinMaxLen )
	{ 
		if ( pch_ptr == NULL )
			return false;

		// Look for a null terminator in string up to pinMaxLen chars.
		for ( unsigned long i = 0; i < pinMaxLen; i++ )
		{
			if ( pch_ptr[ i ] == 0 )
			{ // null terminator found!
				return true;
			}
		}
		
		// no null terminator found - bad string.
		return false;

	} // fboCharStrIsOK

	void fvoCharStrCopy( char *pch_ptrDest, char *pch_ptrSrc, unsigned long pinMaxLen )
	{
		if ( ( pch_ptrDest == NULL ) || ( pch_ptrSrc == NULL ) )
		{
			return;
		}

		// copy from src to dest until maxlen or null terminator is reached
		for ( unsigned long i = 0; i < pinMaxLen; i++ )
		{
			pch_ptrDest[ i ] = pch_ptrSrc[ i ];
			if ( pch_ptrSrc[ i ] == 0 )
			{ // null terminator found
				return;
			}
		}
		
		// no null terminator was found - insert a null terminator.
		pch_ptrDest[ pinMaxLen-1 ] = 0;
		return;

	} // fvoCharStrCopy

	void fvoMakeCharStrReadable ( char *pch_ptrDest, char *pch_ptrSrc, unsigned long pinMaxLen )
	{
		if ( ( pch_ptrDest == NULL ) || ( pch_ptrSrc == NULL ) )
		{
			return;
		}

		fvoCharStrCopy( pch_ptrDest, pch_ptrSrc, pinMaxLen );

		unsigned long vinLen = strlen (pch_ptrDest);

		for ( unsigned long vinIdx = 0; vinIdx < vinLen; vinIdx++ )
		{
			if ( pch_ptrDest [vinIdx] < 32 || pch_ptrDest [vinIdx] > 126 )
			{ // convert all non printable characters to spaces
				pch_ptrDest [vinIdx] = 32;
			}
		}
	} // fboMakeNameReadable

// Converts a string to all upper case as a returned result.
	string ftxToUpper
		(string ptxString)
	{
		string vtxResult;

		for (unsigned int vinIdx = 0; vinIdx < ptxString.length( ); vinIdx++)
		{
			vtxResult += toupper( ptxString[ vinIdx ] );
		}
		
		return vtxResult;

	} // ftxToUpper

	void fvoToUpper 
		(string &ptxString)
	{
		for (unsigned int vinIdx = 0; vinIdx < ptxString.length(); vinIdx++)
		{
			ptxString [vinIdx] = toupper(ptxString[vinIdx]);
		}

	} // ftxToUpper

// Converts a string to all lower case as a returned result.
	string ftxToLower 
		(string ptxString)
	{
		string vtxResult;

		for (unsigned int vinIdx = 0; vinIdx < ptxString.length(); vinIdx++)
		{
			vtxResult += tolower(ptxString[vinIdx]);
		}
		
		return vtxResult;

	} // ftxToLower

	void fvoToLower 
		(string &ptxString)
	{
		for (unsigned int vinIdx = 0; vinIdx < ptxString.length(); vinIdx++)
		{
			ptxString [vinIdx] = tolower( ptxString[ vinIdx ] );
		}

	} // ftxToLower

// truncate string if larger than pinLength.
	string ftxTrunc( string ptxString, unsigned int pinLength )
	{
		if ( ptxString.length( ) > pinLength )
		{
			ptxString.resize( pinLength );
		}
		return ptxString;
	} // ftxTrunc

// truncate string if larger than pinLength.
	void fvoTrunc( string &ptxString, unsigned  pinLength )
	{
		if ( ptxString.length( ) > pinLength )
		{
			ptxString.resize( pinLength );
		}

	} // fvoTrunc

	int finStringToInt (string ptxString)
	{ // returns 0 if conversion not successfull.
		return atoi( ptxString.c_str( ) );
	}

	unsigned int finStringToUInt (string ptxString)
	{ // returns 0 if conversion not successfull.
		return atol( ptxString.c_str( ) );
	}

	float fflStringToFloat( string ptxString )
	{
		return atof( ptxString.c_str( ) );
	}

	string ftxIntToString( int pinValue )
	{

		//	char *itoa(int value, char *string, int radix);
      
		char vch_ary [33];
		itoa( pinValue, vch_ary, 10 );
		string vtxString = vch_ary;
		return vtxString;

	} // ftxIntToString

	string ftxUIntToString( unsigned int pinValue )
	{

		//	char *itoa(int value, char *string, int radix);
      
		char vch_ary [33];
		itoa( pinValue, vch_ary, 10);
		string vtxString = vch_ary;
		return vtxString;

	} // ftxUIntToString

	string ftxLongToString( long plgValue )
	{

		//	char *itoa(int value, char *string, int radix);
      
		char vch_ary [33];
		ltoa( plgValue, vch_ary, 10 );
		string vtxString = vch_ary;
		return vtxString;

	} // ftxLongToString

	string ftxFloatToString( float pflValue, int pinPrecision )
	{
		char vch_ary [33];
		if ( pinPrecision < 0 )
			pinPrecision = 0;
		else
		if ( pinPrecision > 6 )
			pinPrecision = 6;
		string vtxFormat = "%0." + ftxIntToString( pinPrecision ) + "f" ;
		sprintf( vch_ary, vtxFormat.c_str( ), pflValue );
		string vtxOutput = vch_ary;
		return vtxOutput;
	} // ftxFloatToString

	string ftxFloatToString( float pflValue )
	{
		return ftxFloatToString( pflValue, 2 );
	} // ftxFloatToString

	string ftxVectorToString( tstVector pstV )
	{
		return "(" + ftxFloatToString( pstV.x ) + ", " + 
						 ftxFloatToString( pstV.y ) + ", " + 
						 ftxFloatToString( pstV.z )  + ")";
	} // ftxVectorToString

	string ftxBoolToStr( bool pboBool, string ptxTrueStr, string ptxFalseStr )
	{
		if ( ( pboBool != true ) 
					&& 
			  ( pboBool != false ) )
			return "?";

		if ( pboBool == true )
			return "yes";

		return "no";

	} // ftxBoolToStr

	string fxtFillLead( string ptxInStr, unsigned long plgWidth, char pchFill )
	{

		if ( plgWidth < 0 ) plgWidth = 0;

		string vtxOutStr = "";
		
		if ( ptxInStr.length( ) > plgWidth )
		{
			pchFill = '*';
			ptxInStr = "";
		}

		unsigned long vlgFillCount		 = plgWidth - ptxInStr.length( );
		unsigned long vlgFillRemaining = vlgFillCount;

		for ( unsigned long vlgIdx = 0; vlgIdx < vlgFillCount; vlgIdx++)
		{
			if ( vlgFillRemaining > 0 )
			{
				vtxOutStr += pchFill;
				vlgFillRemaining--;
				continue;
			}
		}

		for ( unsigned long vlgIdx = 0; vlgIdx < ptxInStr.length( ); vlgIdx++)
			vtxOutStr += ptxInStr[ vlgIdx ];

		return vtxOutStr;

	} // fxtFillLead

	string fxtFillTrail( string ptxInStr, unsigned long plgWidth, char pchFill )
	{

		if ( plgWidth < 0 ) plgWidth = 0;

		string vtxOutStr = "";
		
		if ( ptxInStr.length( ) > plgWidth )
		{
			pchFill = '*';
			ptxInStr = "";
		}

		for ( unsigned long vlgIdx = 0; vlgIdx < ptxInStr.length( ); vlgIdx++)
			vtxOutStr += ptxInStr[ vlgIdx ];

		unsigned long vlgFillCount		 = plgWidth - ptxInStr.length( );
		unsigned long vlgFillRemaining = vlgFillCount;

		for ( unsigned long vlgIdx = 0; vlgIdx < vlgFillCount; vlgIdx++)
		{
			if ( vlgFillRemaining > 0 )
			{
				vtxOutStr += pchFill;
				vlgFillRemaining--;
				continue;
			}
		}

		return vtxOutStr;

	} // fxtFillTrail

	string ftxIntToStringF( long plgValue, unsigned long plgWidth, char pchFillDir, char pchFill )
	{

		string vtxInStr = ftxIntToString( plgValue );
		if ( pchFillDir == '<' )
			return fxtFillLead( vtxInStr, plgWidth, pchFill );

		if ( pchFillDir == '>' )
			return fxtFillTrail( vtxInStr, plgWidth, pchFill );

		return vtxInStr;

	} // ftxIntToStringF

	string ftxTrimL( string ptxInStr )
	{ // strip out leading spaces, tabs and linefeeds
		if ( ptxInStr.empty( ) )
			return "";

		string vtxOutStr = "";

		int vinLen = ptxInStr.length( );
		bool vboTrimming = true;
		
		for ( int vinIdx = 0; vinIdx < vinLen; vinIdx++ )
		{
			if ( vboTrimming )
			{
				if ( ( ptxInStr[ vinIdx ] == ' ' )
							|| 
					  ( ptxInStr[ vinIdx ] == '\t' )	
							|| 
					  ( ptxInStr[ vinIdx ] == '\n' )	)
					continue;

				vboTrimming = false;
			}

			vtxOutStr += ptxInStr[ vinIdx ];
		}

		return vtxOutStr;

	} // ftxTrimL

	string ftxTrimR( string ptxInStr )
	{ // strip out trailing spaces, tabs and linefeeds
		if ( ptxInStr.empty( ) )
			return "";

		string vtxOutStr = "";

		int vinLen = ptxInStr.length( );
		vinLen--;
		bool vboTrimming = true;
		
		for ( int vinIdx = vinLen; vinIdx >= 0; vinIdx-- )
		{
			if ( vboTrimming )
			{  
				if ( ( ptxInStr[ vinIdx ] == ' ' )
							|| 
					  ( ptxInStr[ vinIdx ] == '\t' ) 
							|| 
					  ( ptxInStr[ vinIdx ] == '\n' )	)

					continue;

				vboTrimming = false;
			}
			vtxOutStr = ptxInStr[ vinIdx ] + vtxOutStr;
		}

		return vtxOutStr;

	} // ftxTrimR

	string ftxTrim( string ptxInStr )
	{
		if ( ptxInStr.empty( ) )
			return "";

		string vtxOutStr;
		
		vtxOutStr = ftxTrimR( ptxInStr );
		vtxOutStr = ftxTrimL( vtxOutStr );

		return vtxOutStr;

	} // ftxTrim

	string ftxExtractFilePath( string ptxFilePath )
	{
		string vtxFilePath;

		// find first occurance of '\' character scanning backwards;
		long vinIdx_Path;
		for ( vinIdx_Path = ptxFilePath.length( ) - 1; vinIdx_Path >= 0; vinIdx_Path-- )
		{
			if ( ptxFilePath[ vinIdx_Path ] == '\\' )
			{
				goto locPathFound; 
			}
		}

		locPathFound:
		if ( vinIdx_Path >= 2 ) // minimum path size;
		{
			vtxFilePath = "";
			for ( long vinIdx = 0; vinIdx <= vinIdx_Path; vinIdx++ )
				vtxFilePath += ptxFilePath[ vinIdx ];
		}
		
		return vtxFilePath;

	} // ftxExtractFilePath

	string ftxQuoteWrap( string ptxFilePath )
	{
		string vtxBQuote;
		string vtxEQuote;

		ptxFilePath	= '"' + ptxFilePath + '"';
		return ptxFilePath;

	} // ftxQuoteWrap

	bool fboFileExists( string ptxFileName )
	{
		return access( ptxFileName.c_str( ), 0 ) == 0;
	} // fboFileExists

	bool fboFileCanBeRead( string ptxFileName )
	{
		return ( access( ptxFileName.c_str( ), 4 ) == 0 );
	} // fboFileCanBeRead

	bool fboFileCanBeWritten( string ptxFileName )
	{
		return ( access( ptxFileName.c_str( ), 4 ) == 0 );
	} // fboFileCanBeWritten

	int finRandom( int pinMin, int pinMax )
	{
		if ( pinMin > pinMax )
		{ // swap
			int vinMin = pinMin;
			pinMin = pinMax;
			pinMax = vinMin;
		}
		return pinMin + random( ( pinMax - pinMin ) + 1 ); 
	} // finRandom

	float fflMinOf( float pflV1, float pflV2 )
	{
		if ( pflV1 < pflV2 )
			return pflV1;

		return pflV2;

	} // fflMinOf

	float fflMaxOf( float pflV1, float pflV2 )
	{
		if ( pflV1 > pflV2 )
			return pflV1;

		return pflV2;

	} // fflMaxOf